
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>android WebView详解，常见漏洞详解和安全源码 / 憋错料</title>

    <meta name="description" content="android WebView详解，常见漏洞详解和安全源码 这篇博客主要来介绍 WebView 的相关使用方法,常见的几个漏洞,开发中可能遇到的坑和最后解决相应漏洞的源码,以及针对该源码的解析. 由于博客内容长度,这次将分为上下两篇,上篇详解 WebView 的使用,下篇讲述 WebView 的漏洞和坑,以及修复源码的解析. 下篇:android WebView详解,常见漏洞详解和安全源码(下) 转载请注明出处:http://blog.csdn.net/self_study/article/details/54928371. 对技术感兴趣的同鞋加群 54">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">android WebView详解，常见漏洞详解和安全源码</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>　　这篇博客主要来介绍 WebView 的相关使用方法，常见的几个漏洞，开发中可能遇到的坑和最后解决相应漏洞的源码，以及针对该源码的解析。</p>
<p>　　由于博客内容长度，这次将分为上下两篇，上篇详解 WebView 的使用，下篇讲述 WebView  的漏洞和坑，以及修复源码的解析。</p>
<p>　　下篇：<a href="http://blog.csdn.net/self_study/article/details/55046348" rel="external nofollow noreferrer">android WebView详解，常见漏洞详解和安全源码（下）</a></p>
<p>　　转载请注明出处：<a href="http://blog.csdn.net/self_study/article/details/54928371" rel="external nofollow noreferrer">http://blog.csdn.net/self_study/article/details/54928371</a>。</p>
<p>　　对技术感兴趣的同鞋加群 544645972 一起交流。</p>
<h1><strong>Android Hybrid 和 WebView 解析</strong></h1>
<p>　　现在市面上的 APP 根据类型大致可以分为 3 类：Native APP、Web APP 和 Hybrid APP，而 Hybrid APP 兼具 “Native APP 良好用户交互体验的优势”和 “Web APP 跨平台开发的优势”，现在很多的主流应用也是使用 Hybrid 模式开发的。</p>
<h2><strong>Hybrid 的优势与原生的体验差距</strong></h2>
<h3><strong>Hybrid 的优势</strong></h3>
<p>　　为什么要使用 Hybrid 开发呢，这就要提到 native 开发的限制：</p>
<p>　　<strong>1.客户端发板周期长</strong></p>
<p>　　　　众所周知，客户端的发板周期在正常情况下比较长，就算是创业公司的迭代也在一到两个星期一次，大公司的迭代周期一般都在月这个数量级别上，而且 Android 还好，iOS 的审核就算变短了也有几天，而且可能会有审核不通过的意外情况出现，所谓为了应对业务的快速发展，很多业务比如一些活动页面就可以使用 H5 来进行开发。</p>
<p>　　<strong>2.客户端大小体积受限</strong></p>
<p>　　　　如果所有的东西都使用 native 开发，比如上面提到的活动页面，就会造成大量的资源文件要加入到 APK 中，这就造成 APK 大小增加，而且有的活动页面更新很快，造成资源文件可能只会使用一个版本，如果不及时清理，就会造成资源文件的残留。</p>
<p>　　<strong>3.web 页面的体验问题</strong></p>
<p>　　　　使用纯 Web 开发，比以前迭代快速很多，但是从某种程度上来说，还是不如原生页面的交互体验好；</p>
<p>　　<strong>4.无法跨平台</strong></p>
<p>　　　　一般情况下，同一样的页面在 android 和 iOS 上需要写两份不同的代码，但是现在只需要写一份即可，Hybrid 具有跨平台的优势。</p>
<p>　　所以综上这两种方式单独处理都不是特别好，考虑到发版周期不定，而且体验交互上也不能很差，所以就把两种方式综合起来，让终端和前端共同开发一个 APP，这样一些迭代很稳定的页面就可以使用原生，增加体验性；一些迭代很快速的页面就可以使用 H5，让两种优点结合起来，弥补原来单个开发模式的缺点。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNzAxMTYxNjA4Mzg2MDI/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2YzJWc1psOXpkSFZrZVE9PS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L1NvdXRoRWFzdA==.jpg"></p>
<h3><strong>H5 与 Native 的体验差距</strong></h3>
<p>　　H5 和 Native 的体验差距主要在两个方面：</p>
<p>　　<strong>1.页面渲染瓶颈</strong></p>
<p>　　　　第一个是前端页面代码渲染，受限于 JS 的解析效率，以及手机硬件设备的一些性能，所以从这个角度来说，我们应用开发者是很难从根本上解决这个问题的；</p>
<p>　　<strong>2.资源加载缓慢</strong></p>
<p>　　　　第二个方面是 H5 页面是从服务器上下发的，客户端的页面在内存里面，在页面加载时间上面，根据网络状况的不同，H5 页面的体验和 Native 在很多情况下相比差距还是不小的，但是这种问题从某种程度上来说也是可以弥补的，比如说我们可以做一些资源预加载的方案，在资源预加载方面，其实也有很多种方式，下面主要列举了一些：</p>
<ul>
<li>第一种方式是使用 WebView 自身的缓存机制：</li>
<p>如果我们在 APP 里面访问一个页面，短时间内再次访问这个页面的时候，就会感觉到第二次打开的时候顺畅很多，加载速度比第一次的时间要短，这个就是因为 WebView 自身内部会做一些缓存，只要打开过的资源，他都会试着缓存到本地，第二次需要访问的时候他直接从本地读取，但是这个读取其实是不太稳定的东西，关掉之后，或者说这种缓存失效之后，系统会自动把它清除，我们没办法进行控制。基于这个 WebView 自身的缓存，有一种资源预加载的方案就是，我们在应用启动的时候可以开一个像素的 WebView ，事先去访问一下我们常用的资源，后续打开页面的时候如果再用到这些资源他就可以从本地获取到，页面加载的时间会短一些。</p>
<li>第二种方案是，我们自己去构建，自己管理缓存：</li>
<p>把这些需要预加载的资源放在 APP 里面，他可能是预先放进去的，也可能是后续下载的，问题在于前端这些页面怎么去缓存，两个方案，第一种是前端可以在 H5 打包的时候把里面的资源 URL 进行替换，这样可以直接访问本地的地址；第二种是客户端可以拦截这些网页发出的所有请求做替换：<br /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNzAxMTYxNTM2NDg0NjI/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2YzJWc1psOXpkSFZrZVE9PS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L1NvdXRoRWFzdA==.jpg"><br />这个是美团使用的预加载方案（详情请看：<a href="https://zhuanlan.zhihu.com/p/24202408" rel="external nofollow noreferrer">美团大众点评 Hybrid 化建设</a>），归属于第二种加载方案，每当 WebView 发起资源请求的时候，我们会拦截这些资源的请求，去本地检查一下我们这些静态资源本地离线包有没有。针对本地的缓存文件我们有些策略能够及时的去更新它，为了安全考虑，也需要同时做一些预下载和安全包的加密工作。预下载有以下几点优势：</p>
<ol>
<li>我们拦截了 WebView 里面发出的所有的请求，但是并没有替换里面的前端应用的任何代码，前端这套页面代码可以在 APP 内，或者其他的 APP 里面都可以直接访问，他不需要为我们 APP 做定制化的东西；</li>
<li>这些 URL 请求，他会直接带上先前用户操作所留下的 Cookie ，因为我们没有更改资源原始 URL 地址；</li>
<li>整个前端在用离线包和缓存文件的时候是完全无感知的，前端只用管写一个自己的页面，客户端会帮他处理好这样一些静态资源预加载的问题，有这个离线包的话，加载速度会变快很多，特别是在弱网情况下，没有这些离线包加载速度会慢一些。而且如果本地离线包的版本不能跟 H5 匹配的话，H5 页面也不会发生什么问题。</li>
</ol>
<p>　　实际资源预下载也确实能够有效的增加页面的加载速度，具体的对比可以去看美团的那片文章。</ul>
<p>　　那么什么地方需要使用 Native 开发，什么地方需要使用 H5 开发呢：一般来说 Hybrid 是用在一些快速迭代试错的地方，另外一些非主要产品的页面，也可以使用 Hybrid 去做；但是如果是一些很重要的流程，使用频率很高，特别核心的功能，还是应该使用 Native 开发，让用户得到一个极致的产品体验。</p>
<h2><strong>WebView 详细介绍</strong></h2>
<p>　　我们来看看 Google 官网关于 WebView 的介绍：</p>
<pre><code>A View that displays web pages. This class is the basis upon which you can roll your own web browser
 or simply display some online content within your Activity. It uses the WebKit rendering engine
 to display web pages and includes methods to navigate forward and backward through a history,
 zoom in and out, perform text searches and more.</code></pre>
<p>可以看到 WebView 是一个显示网页的控件，并且可以简单的显示一些在线的内容，并且基于 WebKit 内核，在 Android4.4(API Level 19) 引入了一个基于 Chromium 的新版本 WebView ，这让我们的 WebView 能支持 HTML5 和 CSS3 以及 Javascript，有一点需要注意的是由于 WebView 的升级，对于我们的程序也带来了一些影响，如果我们的 targetSdkVersion 设置的是 18 或者更低， single and narrow column 和 default zoom levels 不再支持。Android4.4 之后有一个特别方便的地方是可以通过 setWebContentDebuggingEnabled() 方法让我们的程序可以进行远程桌面调试。</p>
<h3><strong>WebView 加载页面</strong></h3>
<p>　　WebView 有四个用来加载页面的方法：</p>
<ul>
<li><a href="https://developer.android.com/reference/android/webkit/WebView.html#loadUrl%28java.lang.String%29" rel="external nofollow noreferrer">loadUrl (String url)</a></li>
<li><a href="https://developer.android.com/reference/android/webkit/WebView.html#loadUrl%28java.lang.String, java.util.Map&lt;java.lang.String, java.lang.String%29" rel="external nofollow noreferrer">loadUrl (String url, Map&lt;String, String&gt; additionalHttpHeaders)</a></li>
<li><a href="https://developer.android.com/reference/android/webkit/WebView.html#loadData%28java.lang.String, java.lang.String, java.lang.String%29" rel="external nofollow noreferrer">loadData(String data, String mimeType, String encoding)</a></li>
<li><a href="https://developer.android.com/reference/android/webkit/WebView.html#loadDataWithBaseURL%28java.lang.String, java.lang.String, java.lang.String, java.lang.String, java.lang.String%29" rel="external nofollow noreferrer">loadDataWithBaseURL(String baseUrl, String data, String mimeType, String encoding, String historyUrl)</a></li>
</ul>
<p>　　使用起来较为简单，loadData 方法会有一些坑，在下面的内容会介绍到。</p>
<h3><strong>WebView 常见设置</strong></h3>
<p>　　使用 WebView 的时候，一般都会对其进行一些设置，我们来看看常见的设置：</p>
<pre><code>WebSettings webSettings = webView.getSettings();
//设置了这个属性后我们才能在 WebView 里与我们的 Js 代码进行交互，对于 WebApp 是非常重要的，默认是 false，
//因此我们需要设置为 true，这个本身会有漏洞，具体的下面我会讲到
webSettings.setJavaScriptEnabled(true);

//设置 JS 是否可以打开 WebView 新窗口
webSettings.setJavaScriptCanOpenWindowsAutomatically(true);

//WebView 是否支持多窗口，如果设置为 true，需要重写
//WebChromeClient#onCreateWindow(WebView, boolean, boolean, Message) 函数，默认为 false
webSettings.setSupportMultipleWindows(true);

//这个属性用来设置 WebView 是否能够加载图片资源，需要注意的是，这个方法会控制所有图片，包括那些使用 data URI 协议嵌入
//的图片。使用 setBlockNetworkImage(boolean) 方法来控制仅仅加载使用网络 URI 协议的图片。需要提到的一点是如果这
//个设置从 false 变为 true 之后，所有被内容引用的正在显示的 WebView 图片资源都会自动加载，该标识默认值为 true。
webSettings.setLoadsImagesAutomatically(false);
//标识是否加载网络上的图片（使用 http 或者 https 域名的资源），需要注意的是如果 getLoadsImagesAutomatically()
//不返回 true，这个标识将没有作用。这个标识和上面的标识会互相影响。
webSettings.setBlockNetworkImage(true);

//显示WebView提供的缩放控件
webSettings.setDisplayZoomControls(true);
webSettings.setBuiltInZoomControls(true);

//设置是否启动 WebView API，默认值为 false
webSettings.setDatabaseEnabled(true);

//打开 WebView 的 storage 功能，这样 JS 的 localStorage,sessionStorage 对象才可以使用
webSettings.setDomStorageEnabled(true);

//打开 WebView 的 LBS 功能，这样 JS 的 geolocation 对象才可以使用
webSettings.setGeolocationEnabled(true);
webSettings.setGeolocationDatabasePath("");

//设置是否打开 WebView 表单数据的保存功能
webSettings.setSaveFormData(true);

//设置 WebView 的默认 userAgent 字符串
webSettings.setUserAgentString("");

//设置是否 WebView 支持 “viewport” 的 HTML meta tag，这个标识是用来屏幕自适应的，当这个标识设置为 false 时，
//页面布局的宽度被一直设置为 CSS 中控制的 WebView 的宽度；如果设置为 true 并且页面含有 viewport meta tag，那么
//被这个 tag 声明的宽度将会被使用，如果页面没有这个 tag 或者没有提供一个宽度，那么一个宽型 viewport 将会被使用。
webSettings.setUseWideViewPort(false);

//设置 WebView 的字体，可以通过这个函数，改变 WebView 的字体，默认字体为 "sans-serif"
webSettings.setStandardFontFamily("");
//设置 WebView 字体的大小，默认大小为 16
webSettings.setDefaultFontSize(20);
//设置 WebView 支持的最小字体大小，默认为 8
webSettings.setMinimumFontSize(12);

//设置页面是否支持缩放
webSettings.setSupportZoom(true);
//设置文本的缩放倍数，默认为 100
webSettings.setTextZoom(2);</code></pre>
<p>　　然后还有最常用的 WebViewClient 和 WebChromeClient，WebViewClient主要辅助WebView执行处理各种响应请求事件的，比如：</p>
<ul>
<li>onLoadResource</li>
<li>onPageStart</li>
<li>onPageFinish</li>
<li>onReceiveError</li>
<li>onReceivedHttpAuthRequest</li>
<li>shouldOverrideUrlLoading</li>
</ul>
<p>WebChromeClient 主要辅助 WebView 处理J avaScript 的对话框、网站 Logo、网站 title、load 进度等处理:</p>
<ul>
<li>onCloseWindow(关闭WebView)</li>
<li>onCreateWindow</li>
<li>onJsAlert</li>
<li>onJsPrompt</li>
<li>onJsConfirm</li>
<li>onProgressChanged</li>
<li>onReceivedIcon</li>
<li>onReceivedTitle</li>
<li>onShowCustomView</li>
</ul>
<p>WebView 只是用来处理一些 html 的页面内容，只用 WebViewClient 就行了，如果需要更丰富的处理效果，比如 JS、进度条等，就要用到 WebChromeClient，我们接下来为了处理在特定版本之下的 js 漏洞问题，就需要用到 WebChromeClient。</p>
<p>　　接着还有 WebView 的几种缓存模式：</p>
<ul>
<li>LOAD_CACHE_ONLY</li>
<p>不使用网络，只读取本地缓存数据；</p>
<li>LOAD_DEFAULT</li>
<p>根据 cache-control 决定是否从网络上取数据；</p>
<li>LOAD_CACHE_NORMAL</li>
<p>API level 17 中已经废弃, 从 API level 11 开始作用同 LOAD_DEFAULT 模式 ；</p>
<li>LOAD_NO_CACHE</li>
<p>不使用缓存，只从网络获取数据；</p>
<li>LOAD_CACHE_ELSE_NETWORK</li>
<p>只要本地有，无论是否过期，或者 no-cache，都使用缓存中的数据。</ul>
<p>www.baidu.com 的 cache-control 为 no-cache，在模式 LOAD_DEFAULT 下，无论如何都会从网络上取数据，如果没有网络，就会出现错误页面；在 LOAD_CACHE_ELSE_NETWORK 模式下，无论是否有网，只要本地有缓存，都会加载缓存。本地没有缓存时才从网络上获取，这个和 Http 缓存一致，我不在过多介绍，如果你想自定义缓存策略和时间，可以尝试下，volley 就是使用了 http 定义的缓存时间。</p>
<p>　　清空缓存和清空历史记录，CacheManager 来处理 webview 缓存相关：<code>mWebView.clearCache(true);</code>；清空历史记录<code>mWebview.clearHistory();</code>，这个方法要在 <code>onPageFinished()</code> 的方法之后调用。</p>
<h2><strong>WebView 与 native 的交互</strong></h2>
<p>　　使用 Hybrid 开发的 APP 基本都需要 Native 和 web 页面的 JS 进行交互，下面介绍一下交互的方式。</p>
<h3><strong>js 调用 native</strong></h3>
<p>　　如何让 web 页面调用 native 的代码呢，有三种方式：</p>
<p>　　<strong>第一种方式：通过 addJavascriptInterface 方法进行添加对象映射</strong></p>
<p>　　这种是使用最多的方式了，首先第一步我们需要设置一个属性：</p>
<pre><code>mWebView.getSettings().setJavaScriptEnabled(true);</code></pre>
<p>这个函数会有一个警告，因为在特定的版本之下会有非常危险的漏洞，我们下面将会着重介绍到，设置完这个属性之后，Native 需要定义一个类：</p>
<pre><code>public class JSObject {
    private Context mContext;
    public JSObject(Context context) {
        mContext = context;
    }

    @JavascriptInterface
    public String showToast(String text) {
        Toast.show(mContext, text, Toast.LENGTH_SHORT).show();
        return "success";
    }
}
...
//特定版本下会存在漏洞
mWebView.addJavascriptInterface(new JSObject(this), "myObj");</code></pre>
<p>需要注意的是在 API17 版本之后，需要在被调用的地方加上 @addJavascriptInterface 约束注解，因为不加上注解的方法是没有办法被调用的，JS 代码也很简单：</p>
<pre><code>function showToast(){
    var result = myObj.showToast("我是来自web的Toast");
}</code></pre>
<p>可以看到，这种方式的好处在于使用简单明了，本地和 JS 的约定也很简单，就是对象名称和方法名称约定好即可，缺点就是下面要提到的漏洞问题。</p>
<p>　　<strong>第二种方式：利用 WebViewClient 接口回调方法拦截 url</strong></p>
<p>　　这种方式其实实现也很简单，使用的频次也很高，上面我们介绍到了 WebViewClient ，其中有个回调接口 <a href="https://developer.android.com/reference/android/webkit/WebViewClient.html#shouldOverrideUrlLoading%28android.webkit.WebView, java.lang.String%29" rel="external nofollow noreferrer">shouldOverrideUrlLoading (WebView view, String url)</a> ，我们就是利用这个拦截 url，然后解析这个 url 的协议，如果发现是我们预先约定好的协议就开始解析参数，执行相应的逻辑，我们先来看看这个函数的介绍：</p>
<pre><code>Give the host application a chance to take over the control when a new url is about to be loaded in
the current WebView. If WebViewClient is not provided, by default WebView will ask Activity Manager
to choose the proper handler for the url. If WebViewClient is provided, return true means the host
application handles the url, while return false means the current WebView handles the url. This
method is not called for requests using the POST "method".</code></pre>
<p>注意这个方法在 API24 版本已经废弃了，需要使用  <a href="https://developer.android.com/reference/android/webkit/WebViewClient.html#shouldOverrideUrlLoading%28android.webkit.WebView, android.webkit.WebResourceRequest%29" rel="external nofollow noreferrer">shouldOverrideUrlLoading (WebView view, WebResourceRequest request)</a> 替代，使用方法很类似，我们这里就使用 <a href="https://developer.android.com/reference/android/webkit/WebViewClient.html#shouldOverrideUrlLoading%28android.webkit.WebView, java.lang.String%29" rel="external nofollow noreferrer">shouldOverrideUrlLoading (WebView view, String url)</a> 方法来介绍一下：</p>
<pre><code>public boolean shouldOverrideUrlLoading(WebView view, String url) {
    //假定传入进来的 url = "js://openActivity?arg1=111&amp;arg2=222"，代表需要打开本地页面，并且带入相应的参数
    Uri uri = Uri.parse(url);
    String scheme = uri.getScheme();
    //如果 scheme 为 js，代表为预先约定的 js 协议
    if (scheme.equals("js")) {
          //如果 authority 为 openActivity，代表 web 需要打开一个本地的页面
        if (uri.getAuthority().equals("openActivity")) {
              //解析 web 页面带过来的相关参数
            HashMap&lt;String, String&gt; params = new HashMap&lt;&gt;();
            Set&lt;String&gt; collection = uri.getQueryParameterNames();
            for (String name : collection) {
                params.put(name, uri.getQueryParameter(name));
            }
            Intent intent = new Intent(getContext(), MainActivity.class);
            intent.putExtra("params", params);
            getContext().startActivity(intent);
        }
        //代表应用内部处理完成
        return true;
    }
    return super.shouldOverrideUrlLoading(view, url);
}</code></pre>
<p>代码很简单，这个方法可以拦截 WebView 中加载 url 的过程，得到对应的 url，我们就可以通过这个方法，与网页约定好一个协议，如果匹配，执行相应操作，我们看一下 JS 的代码：</p>
<pre><code>function openActivity(){
    document.location = "js://openActivity?arg1=111&amp;arg2=222";
}</code></pre>
<p>这个代码执行之后，就会触发本地的 shouldOverrideUrlLoading 方法，然后进行参数解析，调用指定方法。这个方式不会存在第一种提到的漏洞问题，但是它也有一个很繁琐的地方是，如果 web 端想要得到方法的返回值，只能通过 WebView 的 loadUrl 方法去执行 JS 方法把返回值传递回去，相关的代码如下：</p>
<pre><code>//java
mWebView.loadUrl("javascript:returnResult(" + result + ")");</code></pre>
<pre><code>//javascript
function returnResult(result){
    alert("result is" + result);
}</code></pre>
<p>所以说第二种方式在返回值方面还是很繁琐的，但是在不需要返回值的情况下，比如打开 Native 页面，还是很合适的，制定好相应的协议，就能够让 web 端具有打开所有本地页面的能力了。</p>
<p>　　<strong>第三种方式：利用 WebChromeClient 回调接口的三个方法拦截消息</strong></p>
<p>　　这个方法的原理和第二种方式原理一样，都是拦截相关接口，只是拦截的接口不一样：</p>
<pre><code>@Override
public boolean onJsAlert(WebView view, String url, String message, JsResult result) {
    return super.onJsAlert(view, url, message, result);
}

@Override
public boolean onJsConfirm(WebView view, String url, String message, JsResult result) {
    return super.onJsConfirm(view, url, message, result);
}

@Override
public boolean onJsPrompt(WebView view, String url, String message, String defaultValue, JsPromptResult result) {
    //假定传入进来的 message = "js://openActivity?arg1=111&amp;arg2=222"，代表需要打开本地页面，并且带入相应的参数
    Uri uri = Uri.parse(message);
    String scheme = uri.getScheme();
    if (scheme.equals("js")) {
        if (uri.getAuthority().equals("openActivity")) {
            HashMap&lt;String, String&gt; params = new HashMap&lt;&gt;();
            Set&lt;String&gt; collection = uri.getQueryParameterNames();
            for (String name : collection) {
                params.put(name, uri.getQueryParameter(name));
            }
            Intent intent = new Intent(getContext(), MainActivity.class);
            intent.putExtra("params", params);
            getContext().startActivity(intent);
            //代表应用内部处理完成
            result.confirm("success");
        }
        return true;
    }
    return super.onJsPrompt(view, url, message, defaultValue, result);
}</code></pre>
<p>和 WebViewClient 一样，这次添加的是 WebChromeClient 接口，可以拦截 JS 中的几个提示方法，也就是几种样式的对话框，在 JS 中有三个常用的对话框方法：</p>
<ul>
<li>onJsAlert 方法是弹出警告框，一般情况下在 Android 中为 Toast，在文本里面加入\n就可以换行；</li>
<li>onJsConfirm 弹出确认框，会返回布尔值，通过这个值可以判断点击时确认还是取消，true表示点击了确认，false表示点击了取消；</li>
<li>onJsPrompt 弹出输入框，点击确认返回输入框中的值，点击取消返回 null。</li>
</ul>
<p>但是这三种对话框都是可以本地拦截到的，所以可以从这里去做一些更改，拦截这些方法，得到他们的内容，进行解析，比如如果是 JS 的协议，则说明为内部协议，进行下一步解析然后进行相关的操作即可，prompt 方法调用如下所示：</p>
<pre><code>function clickprompt(){
    var result=prompt("js://openActivity?arg1=111&amp;arg2=222");
    alert("open activity " + result);
}</code></pre>
<p>这里需要注意的是 prompt 里面的内容是通过 message 传递过来的，并不是第二个参数的 url，返回值是通过 JsPromptResult 对象传递。为什么要拦截 onJsPrompt 方法，而不是拦截其他的两个方法，这个从某种意义上来说都是可行的，但是如果需要返回值给 web 端的话就不行了，因为 onJsAlert 是不能返回值的，而 onJsConfirm 只能够返回确定或者取消两个值，只有 onJsPrompt 方法是可以返回字符串类型的值，操作最全面方便。</p>
<p>　　<strong>以上三种方案的总结和对比</strong></p>
<p>　　以上三种方案都是可行的，在这里总结一下</p>
<ul>
<li>第一种方式：</li>
<p>是现在目前最普遍的用法，方便简洁，但是唯一的不足是在 4.2 系统以下存在漏洞问题；</p>
<li>第二种方式：</li>
<p>通过拦截 url 并解析，如果是已经约定好的协议则进行相应规定好的操作，缺点就是协议的约束需要记录一个规范的文档，而且从 Native 层往 Web 层传递值比较繁琐，优点就是不会存在漏洞，iOS7 之下的版本就是使用的这种方式。</p>
<li>第三种方式：</li>
<p>和第二种方式的思想其实是类似的，只是拦截的方法变了，这里拦截了 JS 中的三种对话框方法，而这三种对话框方法的区别就在于返回值问题，alert 对话框没有返回值，confirm 的对话框方法只有两种状态的返回值，prompt 对话框方法可以返回任意类型的返回值，缺点就是协议的制定比较麻烦，需要记录详细的文档，但是不会存在第二种方法的漏洞问题。</ul>
<h3><strong>native 调用 js</strong></h3>
<p>　　<strong>第一种方式</strong></p>
<p>　　native 调用 js 的方法上面已经介绍到了，方法为：</p>
<pre><code>//java
mWebView.loadUrl("javascript:show(" + result + ")");</code></pre>
<pre><code>//javascript
&lt;script type="text/javascript"&gt;

function show(result){
    alert("result"=result);
    return "success";
}

&lt;/script&gt;</code></pre>
<p>需要注意的是名字一定要对应上，要不然是调用不成功的，而且还有一点是 JS 的调用一定要在 onPageFinished 函数回调之后才能调用，要不然也是会失败的。</p>
<p>　　<strong>第二种方式</strong></p>
<p>　　如果现在有需求，我们要得到一个 Native 调用 Web 的回调怎么办，Google 在 Android4.4 为我们新增加了一个新方法，这个方法比 loadUrl 方法更加方便简洁，而且比 loadUrl 效率更高，因为 loadUrl 的执行会造成页面刷新一次，这个方法不会，因为这个方法是在 4.4 版本才引入的，所以我们使用的时候需要添加版本的判断：</p>
<pre><code>final int version = Build.VERSION.SDK_INT;
if (version &lt; 18) {
    mWebView.loadUrl(jsStr);
} else {
    mWebView.evaluateJavascript(jsStr, new ValueCallback&lt;String&gt;() {
        @Override
        public void onReceiveValue(String value) {
            //此处为 js 返回的结果
        }
    });
}</code></pre>
<p>　　<strong>两种方式的对比</strong></p>
<p>　　一般最常使用的就是第一种方法，但是第一种方法获取返回的值比较麻烦，而第二种方法由于是在 4.4 版本引入的，所以局限性比较大。</p>
<h2><strong>WebView 常见漏洞和坑</strong></h2>
<p>　　常见漏洞和坑请看下篇博客：<a href="http://blog.csdn.net/self_study/article/details/55046348" rel="external nofollow noreferrer">android WebView详解，常见漏洞详解和安全源码（下）</a></p>
<h1><strong>源码</strong></h1>
<p>　　源码解析请看下篇博客：<a href="http://blog.csdn.net/self_study/article/details/55046348" rel="external nofollow noreferrer">android WebView详解，常见漏洞详解和安全源码（下）</a></p>
<p>　　下载源码：<a href="https://github.com/zhaozepeng/SafeWebView" rel="external nofollow noreferrer">https://github.com/zhaozepeng/SafeWebView</a>；参考自：<a href="https://github.com/yushiwo/WebViewBugDemo" rel="external nofollow noreferrer">https://github.com/yushiwo/WebViewBugDemo</a>，在此基础上做了一些优化。</p>
<p>　　转载请注明出处：<a href="http://blog.csdn.net/self_study/article/details/54928371" rel="external nofollow noreferrer">http://blog.csdn.net/self_study/article/details/54928371</a>。</p>
<h1><strong>引用</strong></h1>
<blockquote><p><a href="http://group.jobbole.com/26417/?utm_source=android.jobbole.com&amp;utm_medium=sidebar-group-topic" rel="external nofollow noreferrer">http://group.jobbole.com/26417/?utm_source=android.jobbole.com&amp;utm_medium=sidebar-group-topic</a></p>
<p><a href="http://blog.csdn.net/jiangwei0910410003/article/details/52687530" rel="external nofollow noreferrer">http://blog.csdn.net/jiangwei0910410003/article/details/52687530</a></p>
<p><a href="http://blog.csdn.net/leehong2005/article/details/11808557" rel="external nofollow noreferrer">http://blog.csdn.net/leehong2005/article/details/11808557</a></p>
<p><a href="https://github.com/yushiwo/WebViewBugDemo/blob/master/src/com/lee/webviewbug/WebViewEx.java" rel="external nofollow noreferrer">https://github.com/yushiwo/WebViewBugDemo/blob/master/src/com/lee/webviewbug/WebViewEx.java</a></p>
<p><a href="http://blog.csdn.net/sk719887916/article/details/52402470" rel="external nofollow noreferrer">http://blog.csdn.net/sk719887916/article/details/52402470</a></p>
<p><a href="https://zhuanlan.zhihu.com/p/24202408" rel="external nofollow noreferrer">https://zhuanlan.zhihu.com/p/24202408</a></p>
<p><a href="https://github.com/lzyzsd/JsBridge" rel="external nofollow noreferrer">https://github.com/lzyzsd/JsBridge</a></p>
<p><a href="http://www.jianshu.com/p/93cea79a2443#" rel="external nofollow noreferrer">http://www.jianshu.com/p/93cea79a2443#</a></p>
<p><a href="http://www.codexiu.cn/android/blog/33214/" rel="external nofollow noreferrer">http://www.codexiu.cn/android/blog/33214/</a></p>
<p><a href="https://github.com/pedant/safe-java-js-webview-bridge" rel="external nofollow noreferrer">https://github.com/pedant/safe-java-js-webview-bridge</a></p>
<p><a href="http://blog.sina.com.cn/s/blog_777f9dbb0102v8by.html" rel="external nofollow noreferrer">http://blog.sina.com.cn/s/blog_777f9dbb0102v8by.html</a></p>
<p><a href="http://www.cnblogs.com/chaoyuehedy/p/5556557.html" rel="external nofollow noreferrer">http://www.cnblogs.com/chaoyuehedy/p/5556557.html</a></p>
<p><a href="http://blogs.360.cn/360mobile/2014/09/22/webview%E8%B7%A8%E6%BA%90%E6%94%BB%E5%87%BB%E5%88%86%E6%9E%90/" rel="external nofollow noreferrer">http://blogs.360.cn/360mobile/2014/09/22/webview%E8%B7%A8%E6%BA%90%E6%94%BB%E5%87%BB%E5%88%86%E6%9E%90/</a></p>
<p><a href="https://my.oschina.net/zhibuji/blog/100580" rel="external nofollow noreferrer">https://my.oschina.net/zhibuji/blog/100580</a></p>
<p><a href="http://www.cnblogs.com/punkisnotdead/p/5062631.html?utm_source=tuicool&amp;utm_medium=referral" rel="external nofollow noreferrer">http://www.cnblogs.com/punkisnotdead/p/5062631.html?utm_source=tuicool&amp;utm_medium=referral</a></p></blockquote>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 08:11:40 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/title/" title="title">title</a>, <a href="https://www.biecuoliao.com/tag/ade/" title="ade">ade</a>, <a href="https://www.biecuoliao.com/tag/rip/" title="rip">rip</a>, <a href="https://www.biecuoliao.com/tag/script/" title="script">script</a>, <a href="https://www.biecuoliao.com/tag/save/" title="save">save</a>, <a href="https://www.biecuoliao.com/tag/target/" title="target">target</a>, <a href="https://www.biecuoliao.com/tag/ota/" title="ota">ota</a>, <a href="https://www.biecuoliao.com/tag/%e5%af%b9%e8%b1%a1%e4%bc%a0%e9%80%92/" title="对象传递">对象传递</a>, <a href="https://www.biecuoliao.com/tag/jscon/" title="jscon">jscon</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>android WebView详解，常见漏洞详解和安全源码的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rbNev3.html" rel="bookmark">android WebView详解，常见漏洞详解和安全源码（下）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				上篇博客主要分析了 WebView 的详细使用,这篇来分析 WebView 的常见漏洞和使用的坑. 上篇:android WebView详解,常见漏洞详解和安全源码(上) 转载请注明出处:http://blog.csdn.net/self_study/article/details/55046348 对技术感兴趣的同鞋加群 544645972 一起交流. WebView 常见漏洞 WebView 的漏洞也是不少,列举一些常见的漏洞,实时更新,如果有其他的常见漏洞,知会一下我-- WebView			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MVb8NyM.html" rel="bookmark">Android FakeID&lpar;Google Bug 13678484&rpar; 漏洞详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				开始 继上一次Masterkey漏洞之后,Bluebox在2014年7月30日又公布了一个关于APK签名的漏洞--FakeID,并打算在今年的Blackhack上公布更详细的细节,不过作者Jeff Forristal在文中已经给出了不少提示,另外申迪的&lt;FakeID签名漏洞分析及利用&gt;也做了相关介绍.由于其中涉及的知识点较多,所以有部分朋友估计还没有看明白,所以我打算写一篇更加详细漏洞分析解说. 基础概念 在分析之前,有几个基础概念需要普及一下的: APK包中的MF.SF和RSA文件 完成签名			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPb86m3.html" rel="bookmark">Android LaunchAnyWhere &lpar;Google Bug 7699048&rpar;漏洞详解及防御措施</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				开始 近日,Google修复一个组件安全的漏洞LaunchAnyWhere(Google Bug 7699048).这个漏洞属于Intend Based提取漏洞,攻击者利用这个漏洞,可以突破了应用间的权限隔离,达到调用任意私有Activity(exported为false)的目的. 该漏洞影响Android 2.3至4.3固件. 漏洞分析 在分析这个漏洞之前,需要先介绍两个东西. Account管理机制 从Android2.0开始,系统引入了Account管理机制,详细使用说明见Android官			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41DgzO3.html" rel="bookmark">Scala 深入浅出实战经典 第60讲：Scala中隐式参数实战详解以及在Spark中的应用源码解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				王家林亲授&lt;DT大数据梦工厂&gt;大数据实战视频 Scala 深入浅出实战经典(1-87讲)完整视频.PPT.代码下载:百度云盘:http://pan.baidu.com/s/1c0noOt6 腾讯微云:http://url.cn/TnGbdC 360云盘:http://yunpan.cn/cQ4c2UALDjSKy 访问密码 45e2土豆:http://www.tudou.com/programs/view/IVN4EuFlmKk/优酷:http://v.youku.com/v_show/id_			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JkVp9M.html" rel="bookmark">Android WebView远程代码执行漏洞简析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				0x00 本文参考Android WebView 远程代码执行漏洞简析.代码地址为,https://github.com/jltxgcy/AppVulnerability/tree/master/WebViewFileDemo.下面我们分析代码. 0x01 首先列出项目工程目录: MainActivity.java的代码如下: public class MainActivity extends Activity { private WebView webView; private Uri mUr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lDWVZ0.html" rel="bookmark">Android 5&period;0内核和源代码学习（2）&mdash;&mdash;源码下载和系统启动过程分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.Android源码下载 上一次简单介绍了Android系统的层次结构,这次开始动真格了--下载源码和分析源码! 那么,Android的源码从哪下?当然是谷歌官网,下载方法官网也讲得很详细,但是奈何中国的墙比较厚,所以上面的办法是没用的,当然,有些是有用的,地址:http://source.android.com/source/downloading.html 谷歌官网没办法下,幸好还有一些国内网站,废话不多说,直接开始步骤: 工具和环境:VM虚拟机+Ubantu14系统 第一步:Ubantu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/412PQYM.html" rel="bookmark">android Listview分批加载&plus;自动加载（附源码下载）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				直接上代码,代码有注释: public class TestForListviewActivity extends Activity implements OnScrollListener { private ListView mListview = null; private View mFooterView; private PaginationAdapter mAdapter; private Handler handler=new Handler(); private boolean i			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDdXawM.html" rel="bookmark">Android事件分发机制完全解析，带你从源码的角度彻底理解&lpar;上&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载请注明出处:http://blog.csdn.net/guolin_blog/article/details/9097463 其实我一直准备写一篇关于Android事件分发机制的文章,从我的第一篇博客开始,就零零散散在好多地方使用到了Android事件分发的知识.也有好多朋友问过我各种问题,比如:onTouch和onTouchEvent有什么区别,又该如何使用?为什么给ListView引入了一个滑动菜单的功能,ListView就不能滚动了?为什么图片轮播器里的图片使用Button而不用Ima			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0YY8Oy0.html" rel="bookmark">Android OpenGL入门示例&colon;绘制三角形和正方形 &lpar;附完整源码&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android上对OpenGl的支持是无缝的,所以才有众多3D效果如此逼真的游戏,在Camera的一些流程中也有用到GLSurfaceView的情况.本文记录OpenGL在Android上的入门级示例,绘制一个三角形和正方形.尽管功能简单,可是我捣腾了好几个晚上,大量网上文章上的代码都有点问题,不是绘制不出来就是挂了. 第一个文件:MainActivity.java package com.example.learnopengl1; import android.opengl.GLSurface			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/n0lplP0.html" rel="bookmark" class="title">经典SQL语句</a>
					<div>
						经典SQL语句大全(绝对的经典) 一.基础 1.说明:创建数据库 CREATE DATABASE database-name 2.说明:删除数据库drop database dbname3.说明:备份 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/n4AB9aM.html" rel="bookmark" class="title">C&plus;&plus;C&plus;&plus; 指针（二）--c&plus;&plus; 指针（二）--c&plus;&plus;</a>
					<div>
						一.内存管理:new和delete 1.new操作符:从操作系统获得内存块,并返回该内存块的首地址. delete操作符:将new申请的内存返还给操作系统. 开始一个简单的例子: #include & ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/N4p7ZK3.html" rel="bookmark" class="title">站立会议01（第二期）</a>
					<div>
						第一阶段完成了校园导航的基本界面的设计.这一阶段主要要实现定位功能,优化操作界面 昨天:对前期进行了一些总结,也对老师的建议进行了一些考虑,争取这一阶段少走点弯路. 今天:由于站立会议中对界面设计讨论 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/x0dm573.html" rel="bookmark" class="title">linux线程同步（队列方式）</a>
					<div>
						看了一些关于信号量的线程同步方式,今天用了一下. 我对于线程同步一直有疑问,在主线程和子线程处理时间不相同的时候,用这种信号量,如何保证同步. 假如主线程比较快,信号量连加了n个,但是子线程就不断减这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0knoy7M.html" rel="bookmark" class="title">nginx实现用户认证访问页面</a>
					<div>
						安装apache支持的htpasswdyum -y install httpd安装完成后查看其路径[[email protected] ~]$ which htpasswd[[email protec ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qoLL5M.html" rel="bookmark" class="title">企业计划体系的变迁：从ERP到APS再到SCP</a>
					<div>
						规划是供应链运作的大脑.几十年来,规划从MRP发展到到ERP到APS再到SCP,经历了从部分到全局,从静态到动态,从企业到供应链的发展历程.供应链的效率取决于规划.规划不到位,任何执行都是事后挽救.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoYjBk3.html" rel="bookmark" class="title">网站安全-目录扫描</a>
					<div>
						利用御剑对目标进行fuzz 多线程扫描需要注意避免被网站封IP 渗透中收集字典. 利用burpsuit爆破网站后台管理界面					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vKzP64.html" rel="bookmark" class="title">&lbrack;BZOJ 1006&rsqb; &lbrack;HNOI2008&rsqb; 神奇的国度 【弦图最小染色】</a>
					<div>
						题目链接: BZOJ - 1006 题目分析 这道题是一个弦图最小染色数的裸的模型. 弦图的最小染色求法,先求出弦图的完美消除序列(MCS算法),再按照完美消除序列,从后向前倒着,给每个点染能染的最小 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyjPRL0.html" rel="bookmark" class="title">docker生态系统</a>
					<div>
						我的docker学习笔记6-docker生态 1.镜像即应用 代码构建.持续集成和持续交付 DaoCloud.Quay.IO 2.催生容器托管caas服务 基于镜像的容器托管业务 存储类.系统类.应用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZDommM.html" rel="bookmark" class="title">HDU  5101  Select（BestCoder Round &num;17）</a>
					<div>
						Problem Description: One day, Dudu, the most clever boy, heard of ACM/ICPC, which is a very interest ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEvQ1g0.html" rel="bookmark" class="title">使用阿里云学生服务器搭建nodejs项目（准备阶段）</a>
					<div>
						最近在阿里云买了一年的学生服务器,准备在上面挂些东西玩玩,折腾了一大晚上,才把node环境搭好,本人是linux菜鸟,记录一下自己第一次使用遇到的坑... 1.我选择的是centos系统,预装php环 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoxlpD0.html" rel="bookmark" class="title">JP柜组装流水线制造工艺及用途</a>
					<div>
						华森自动化设备是一家专业制造JP柜组装流水线,在JP柜组装流水线的质量和价格上有着明显优势. 厂家定制的JP柜组装流水线       JP柜组装流水线制造工艺:JP柜需将在JP柜装配生产流水线上完成一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoalYQ3.html" rel="bookmark" class="title">NOJ1553---Beautiful Walls&lpar;尺取法&rpar;</a>
					<div>
						问题描述 To simplify the building process, XadillaX built some template on the ground. The template is a ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rZrm93.html" rel="bookmark" class="title">aruba无线轻轨项目</a>
					<div>
						在无线网络管理方面,必须具有无线的集中控管.智能调控.自动恢复.负载均衡等实用功能,所建无线网络可以适应多种环境的变化,可动态地保证良好的应用效果.还应具有远端AP数据进行采集.远程监控.终端定位等功 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49WnvJ0.html" rel="bookmark" class="title">Tomcat 保护资源</a>
					<div>
						最近做了个项目,是在之前的adapter上面,做个功能维护的,也就是简单的CRUD,但是问题来了,这个功能没有做权限,也没有做登录,这个放在网络上就是裸奔啊.后来想到了可以借用tomcat的Realm ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoajJl3.html" rel="bookmark" class="title">平衡成本与业务风险 &OpenCurlyDoubleQuote;去IOE&rdquo;话题的思考与实践</a>
					<div>
						很多人谈到&quot;去IOE&quot;话题,会理所当然的认为,将IBM.Oracle.EMC的全部产品从信息架构中移去就是去IOE,其实不然.IOE其实是特指IBM.Oracle.EMC的专有系统 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lk1pWM.html" rel="bookmark" class="title">echart的label标签文字过长显示不全怎么办？</a>
					<div>
						echart的官方只提供label标签文字过长是斜着显示的方式,并且文字显示不全重叠等现象.那么只能自己的方式来实现. option = { title : { text: '世界人口总量', sub ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Jd7ql0.html" rel="bookmark" class="title">Swift基础知识入门（基于Swift2&period;0）</a>
					<div>
						//: Playground - noun: a place where people can play import UIKit // Swift中不需要设置main函数入口,编译器会在全局函数中自 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MV7Anw0.html" rel="bookmark" class="title">关于指针的一些总结</a>
					<div>
						对于动态分配的内存在使用前一定要检验是否分配成功,在使用完成之后进行释放. 检验方法: int *p = (int *)malloc(10 * sizeof(int)); if (p == NULL) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wa7eNM.html" rel="bookmark" class="title">bzoj3638</a>
					<div>
						费用流+线段树 看见这个题我们马上就能想到费用流,设立源汇,分别向每个点连接容量为1费用为0的边,然后相邻的点之间连边,费用为点权,跑费用流就行了,但是很明显这样会超时,那么我们要优化一下,我们观察费 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.035 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
